package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import ninja.thefirearchmage.games.fourtykcalculator.utils.datastructures.Tuple2;
import ninja.thefirearchmage.games.fourtykcalculator.utils.datastructures.Tuple3;

import java.util.List;

/**
 * Models what modifiers a unit that is performing the attacking provides to its weapons.
 * For example, a unit of eradicators has reroll on hits, wounds and damage against monsters and vehicles.
 */
@NoArgsConstructor @Getter @Setter
public class UnitAttackModifiers {
    private Tuple3<Boolean, WeaponRangeType, Integer> sustainedHitsModifier;
    private Tuple2<Boolean, WeaponRangeType> lethalHitsModifier;
    private int criticalHitValue = 6;
    private boolean lanceModifier;
    private List<Reroll> hitRerollsModifier;
    private List<Reroll> woundRerollsModifier;
    private List<Reroll> damageRerollsModifier;
    private Tuple3<Boolean, WeaponRangeType, Integer> apModifier;
    private Tuple2<Boolean, WeaponRangeType> woundBonusModifier;
    private Tuple2<Boolean, WeaponRangeType> woundMalusModifier;
    private Tuple2<Boolean, WeaponRangeType> hitBonusModifier;
    private Tuple2<Boolean, WeaponRangeType> hitMalusModifier;
    private Tuple2<Boolean, WeaponRangeType> devastatingWoundsModifier;
    private Tuple2<Boolean, WeaponRangeType> hazardousModifier;
    private Tuple2<Boolean, WeaponRangeType> heavyModifier;
    private Tuple3<Boolean, WeaponRangeType, Integer> strengthModifier;
    private Tuple3<Boolean, WeaponRangeType, Integer> attacksBonusModifier;
    private Tuple3<Boolean, WeaponRangeType, Integer> attacksMalusModifier;
    private Tuple3<Boolean, WeaponRangeType, Integer> rapidFireModifier;
    private boolean unmodifiableHitRoll;
    private boolean fishForCriticalHits;
    private boolean fishForCriticalWounds;

    private boolean unitHasRemainedStationaryModifier;
    private boolean unitCharged;
    private boolean targetInRapidFireRange;
    private boolean isPsychic;
    private boolean canRerollHazardous;

    public boolean hasReroll
}
